Subject: bug#68200: 30.0.50; Emacs reloads init file when calling `documentation'

From: Alan Mackenzie <[email-masked]>
Date: Mon, 8 Jan 2024 21:22:16 +0000

Hello, Michael.

On Sun, Jan 07, 2024 at 18:33:39 +0100, Michael Heerdegen wrote:
> Eli Zaretskii <[email-masked]> writes:

> > > Looks to me like Fdocumentation detects that the file containing the doc
> > > has changed, and that it needs to reload it. I think you mentioned that
> > > this happens when you change the file and existing Emacs sessions do the
> > > reload? In that case, this looks like normal behaviour to me, unless I'm
> > > overlooking something?

> > Right.

> Looks like

>   6a01a1a856f ".elc format: Record lambdas' doc strings lazily, not
>   inline" (Alan Mackenzie <[email-masked]> 2023-11-26)

> would be related.

> Alan, could this be the case?

Yes, I think it could.  I've not yet got my brain into that commit from
November (which was quite a long time ago), but ....

In an age when a computer with 1 GB RAM is regarded as small indeed, why
are we so concerned about the, at most, few hundred bytes occupied by
each doc string?  Even if certain libraries were given adequate doc
strings, that still wouldn't swell the occupied storage to more than...
Well, I think there are around 40,000 defuns (etc.) in Emacs (I did scan
the source files for this at one time).  If each doc string were on
average 1024 bytes, that would come to around 40 MB.  That's negligible
these days, surely.

Eli, what would you say to changing the default of the custom variable
byte-compile-dynamic-docstrings to nil?

And I'll have a look at why that variable no longer appears to be
working (though I have rather a lot on in the next few days).

> TIA,

> Michael.

-- 
Alan Mackenzie (Nuremberg, Germany).